# RepeatMasker to GFF file conversion

import sys

FileNames = sys.argv[1:]

def Quit(s):
	print >> sys.stderr, "*** ERROR ***", sys.argv[0], s
	sys.exit(1)

def GetLine():
	global Line
	Line = File.readline()
	if len(Line) == 0:
		print >> sys.stderr, "*** Unexpected end-of-file ***"
		sys.exit(1)
	return Line

def Pos(s):
	if s[0] == "(":
		return int(s[1:-1])
	return int(s)

for FileName in FileNames:
	File = open(FileName)

	# Skip 3 header lines
	File.readline()
	File.readline()
	File.readline()

	LineNr = 3
	while 1:
		Line = File.readline()
		if len(Line) == 0:
			break
		LineNr += 1
		Fields = Line.split()
	# Hack case where no class/family field
		# if len(Fields) == 14 or (len(Fields) == 15 and Fields[14] == "*"):
		if not Fields[11][0].isdigit() and Fields[11][0] != '(' and Fields[11][0] != '-':
			if len(Fields) == 14:
				Fields.append(Fields[13])
			Fields[13] = Fields[12]
			Fields[12] = Fields[11]
			Fields[11] = Fields[10]
			Fields[10] = "RM"
#		if len(Fields) != 15 and len(Fields) != 16:
#			print >> sys.stderr, "Expected 15 or 16 fields, got ", len(Fields), Line
#			sys.exit(1)
		
	#   SW  perc perc perc  query                 position in query            +  matching      repeat          position in  repeat
	# score  div. del. ins.  sequence                 begin      end     (left)   repeat        class/family     begin   end (left)   ID [*]
	#     0    1    2    3   4                          5         6         7 8           9      10                   11      12      13
	# 8385  0.7  0.2  0.0 Cms                       3126      4203  (3254442 C  Cms.IScms1      Unknown             (0)    1080       1
    #	26  6.4  0.0  0.0 Cms                      15588     15634  (3243011 C  GC_rich         Low_complexity    (232)      68      22
	#  201 24.4  0.0  0.0 Cms                      17960     18004  (3240641 +  (CGA)n          Simple_repeat         2      46   (134)
	#  612  24.8  4.8  3.4  gb|AE002566|AE002566        19      229 (10562902) +  SAR_DM        Satellite            1   214    (0)    1  
	#    0     1    2    3                     4         5        6          7 8       9               10           11    12     13   14 15
		for i in range(0, len(Fields)):
			Fields[i] = Fields[i].strip()

		SWScore = int(Fields[0])
	#	PctDiv = float(Fields[1])
	#	PctDel = float(Fields[2])
	#	PctIns = float(Fields[3])
		ContigLabel = Fields[4]
		Strand = Fields[8]

		if Fields[7][0] == "(":
			ContigFrom = Pos(Fields[5])
			ContigTo = Pos(Fields[6])
			ContigLeft = Pos(Fields[7])
		else:
			Quit("5,6,7")

		RepeatName = Fields[9]
		RepeatFamily = Fields[10]

		if Fields[13][0] == "(":
			RepeatFrom = Pos(Fields[11])
			RepeatTo = Pos(Fields[12])
			RepeatLeft = Pos(Fields[13])
			if Strand != "+":
				Quit("Strand=" + Strand)
		elif Fields[11][0] == "(":
			RepeatFrom = Pos(Fields[13])
			RepeatTo = Pos(Fields[12])
			RepeatLeft = Pos(Fields[11])
			if Strand != "C":
				Quit("Strand=" + Strand)
		else:
			for i in range(0, len(Fields)):
				print >> sys.stderr, "Fields[" + str(i) + "] = " + Fields[i]
			print >> sys.stderr
			print >> sys.stderr, "Line", LineNr
			print >> sys.stderr, Line
			Quit("Failed to find '(', 11='" + Fields[11] + "' 13='" + Fields[13] + "'")

		# ID = int(Fields[14])

		if Strand == "+":
			Rev = "+"
		elif Strand == "C":
			Rev = "-"
		else:
			Quit("Strand=" + Strand)
		
		strRepeatFrom = str(RepeatFrom)
		strRepeatTo = str(RepeatTo)
		strRepeatLeft = str(RepeatLeft)
		if RepeatFamily == "Low_complexity" or RepeatFamily == "Simple_repeat":
			strRepeatFrom = "."
			strRepeatTo = "."
			strRepeatLeft = "."
		
# GFF fields are:
# <seqname> <source> <feature> <start> <end> <score> <strand> <frame> [attributes] [comments]
#     0         1         2        3      4      5        6       7         8           9
		s = "%s\tRepeatMasker\trepeat\t%d\t%d\t%d\t%s\t.\tRepeat %s %s %s %s %s" % \
		  ( ContigLabel, ContigFrom, ContigTo, SWScore, Rev, RepeatName, RepeatFamily, strRepeatFrom, strRepeatTo, strRepeatLeft)
		print s
